@if exp="typeof(global.exframe_object) == 'undefined'"
@iscript

// gt[

class KAGFrameExtensionPlugin extends KAGPlugin
{

	// dictionary: xۑΏ
	var dopt; // ftHgIvV
	var ldic; // bZ[WCPʂł̕ۑ (index=layernum)
	var window; // EBhEւ̎QƁi܂Aglobal.kagj

	var cachelayer; // LbVpC
	var cacheinfo; // LbV

	var copyFuncFlag;
	/*const*/var cffCopy = 0x01;
	/*const*/var cffOperate = 0x04;

	// RXgN^
	function KAGFrameExtensionPlugin(window)
	{
		// ClockPlugin RXgN^
		super.KAGPlugin(); // X[p[NX̃RXgN^Ă

		initDefaultOptions();

		this.window = window;
		window.add(cachelayer = new global.Layer(window, window.primaryLayer));

		copyFuncFlag = cffCopy;

		cacheinfo = %[
			"width" => 0,
			"height" => 0,
			"layernum" => -1,
			"enabled" => true, // LbV@\𖳌ɂꍇ͂falseɂB
		];
	}

	// fXgN^
	function finalize()
	{
		invalidate dopt;
		invalidate ldic;
		super.finalize(...);
	}

	function initDefaultOptions()
	{
		// ftHgݒ
		dopt = %[
			// UI
			"gradenable" => false,
			"gradcolor1" => 0xffffff,
			"gradcolor2" => 0x000000,
			"gradopacity" => 0xbf,
			"cornerwidth" => 16,
			"cornerheight" => 16,
			"frametransparent" => true,
			"frameopacity" => 0xff,

			// p
			"Name" => "",
			"MetaFile" => "",
			"PatternFile" => "",
			"FrameFile" => "",
			"FrameEdgeWidth" => 1,
			"FrameEedgWheight" => 1,
		];

		ldic = new Array();
	}


	// IvVݒ
	function setOptions(mp)
	{
		// K{
		var name  = mp.name;
		var layernum = mp.layer;
		var layer = window.fore.messages[layernum];

		if (layer === void) return false;
		if (name  === void) return false;

		// MessageLayer.clearLayer()㏑
		overrideLayerFunc(layernum);

		// ftHgݒ
		if (ldic[layernum] === void)
		{
			ldic[layernum] = new Dictionary();
			// ftHgl𔽉f
			(Dictionary.assign incontextof ldic[layernum])(dopt);
		}

		var xf = ldic[layernum];
		// 댯Ȃ̂ō폜
		delete xf.name;
		delete xf.layer;
		delete xf.update;

		var FrameSetName = "exframe/" + name;

		xf.MetaFile    = FrameSetName + "/default.tjs";
		xf.FrameFile   = FrameSetName + "/frame";
		xf.PatternFile = FrameSetName + "/pattern";

		// ^񃍁[h
		// t@CƃG[[
		var exdef = Scripts.evalStorage(xf.MetaFile);
		// ㏑
		addElem(exdef, xf);
		// [Uwŏ㏑
		addElem(mp, xf);

		// g[h
		var wf0 = new global.Layer(this.window, layer);
		var wfEnabled = true;
		try
		{
			wf0.loadImages(xf.FrameFile);
			with (wf0)
			{
				.setSizeToImageSize();
				xf.cornerwidth  = .width  \ 3;
				xf.cornerheight = .height \ 3;
			}
		}
		catch
		{
			wfEnabled = false;
			xf.FrameFile = "";
		}

		if (wfEnabled)
		{
			//GbW̃TCY
			with (xf)
			{
				if (
					.cornerwidth  <= 0 ||
					.cornerwidth  > (wf0.width \ 2) ||
					.cornerheight <= 0 ||
					.cornerheight > (wf0.height \ 2))
				{
					.cornerwidth  = wf0.width  \ 3;
					.cornerheight = wf0.height \ 3;
				}

				.FrameEdgeWidth  = wf0.width  - .cornerwidth  * 2;
				.FrameEdgeHeight = wf0.height - .cornerheight * 2;
			}
		}

		// np^[[h
		var ch0 = new global.Layer(this.window, layer);
		try
		{
			ch0.loadImages(xf.PatternFile);
		}
		catch
		{
			xf.PatternFile = "";
		}

		invalidate wf0;
		invalidate ch0;

		// LbVȂAȂ
		cacheinfo.layernum = -1;

		if (mp.update) drawFrame(layernum);

	}


	// IvV폜
	function deleteOptions(mp)
	{
		// K{
		var layernum = mp.layer;

		if (layernum === void) return false;
		if (ldic[layernum] === void) return false;

		ldic[layernum] = void;
	}

	// `
	function drawFrame(layernum)
	{
		var layer = window.fore.messages[layernum];
		var xf = ldic[layernum];

		if (layer === void) return false;
		if (xf === void) return false;

		// LbV
		var cacheOK = 
			cacheinfo.enabled && 
			cacheinfo.layernum == layernum && 
			cacheinfo.width == layer.imageWidth && 
			cacheinfo.height == layer.imageHeight;

		if (cacheOK)
		{
			layer.copyRect(0, 0, cachelayer, 0, 0, cachelayer.imageWidth, cachelayer.imageHeight);
			return;
		}

		// g[h
		var wf0 = new global.Layer(this.window, layer);
		var wfs = new Array();
		wfs.count = 9;
		if (xf.FrameFile != "")
		{
			wf0.loadImages(xf.FrameFile);
			with (wf0) {
				.setSizeToImageSize();
				xf.cornerwidth  = .width  \ 3;
				xf.cornerheight = .height \ 3;
			}
		}

		// np^[[h
		var ch0 = new global.Layer(this.window, layer);
		if (xf.PatternFile != "")
		{
			ch0.loadImages(xf.PatternFile);
			ch0.setSizeToImageSize();
		}

		with (layer)
		{
			// np^[~l
			if (xf.PatternFile != "")
			{
				setCopyFuncFlag(true);
				for (var y = 0; y <= .imageHeight \ ch0.height; y++) {
					for (var x = 0; x <= .imageWidth \ ch0.width; x++) {
						copyFunc(layer, x * ch0.width, y * ch0.height, ch0, 0, 0, ch0.width, ch0.height, omAuto);
					}
				}
			}

			// Of[V
			if (xf.gradenable) {
				var g1R = (xf.gradcolor1 \ 0x10000) & 0xFF;
				var g1G = (xf.gradcolor1 \ 0x00100) & 0xFF;
				var g1B = (xf.gradcolor1 \ 0x00001) & 0xFF;
				var g2R = (xf.gradcolor2 \ 0x10000) & 0xFF;
				var g2G = (xf.gradcolor2 \ 0x00100) & 0xFF;
				var g2B = (xf.gradcolor2 \ 0x00001) & 0xFF;

				for (var y = 0; y < .imageHeight; y++) {
					var gR = y * (g2R - g1R) \ .imageHeight + g1R;
					var gG = y * (g2G - g1G) \ .imageHeight + g1G;
					var gB = y * (g2B - g1B) \ .imageHeight + g1B;
					var col = (gR * 0x10000) + (gG * 0x100) + gB;
					.colorRect(0, y, .imageWidth, 1, col, xf.gradopacity);
				}
			}

			// g
			if (xf.FrameFile != "")
			{
				setCopyFuncFlag(xf.frametransparent);

				// ӁE
				var nChips;
				nChips = (.imageWidth - 2 * xf.cornerwidth - 1) \ xf.FrameEdgeWidth + 1;

				for (var x = 0; x < nChips; x++) {
					var overDraw = (x == nChips - 1) ? ((nChips * xf.FrameEdgeWidth) - (.imageWidth - 2 * xf.cornerwidth)) : 0;
					copyFunc(layer, 
						xf.cornerwidth + x * xf.FrameEdgeWidth, 0, wf0, 
						xf.cornerwidth, 0, xf.FrameEdgeWidth - overDraw, xf.cornerheight, 
						omAuto, xf.frameopacity);
					copyFunc(layer, 
						xf.cornerwidth + x * xf.FrameEdgeWidth, .imageHeight - xf.cornerheight, wf0, 
						xf.cornerwidth, xf.cornerheight + xf.FrameEdgeHeight, xf.FrameEdgeWidth - overDraw, xf.cornerheight, 
						omAuto, xf.frameopacity);
				}

				// ӁEE
				nChips = (.imageHeight - 2 * xf.cornerheight - 1) \ xf.FrameEdgeHeight + 1;
				for (var y = 0; y < nChips; y++) {
					var overDraw = (y == nChips - 1) ? ((nChips * xf.FrameEdgeHeight) - (.imageHeight - 2 * xf.cornerheight)) : 0;
					copyFunc(layer, 
						0, xf.cornerheight + y * xf.FrameEdgeHeight, wf0, 
						0, xf.cornerheight, xf.cornerwidth, xf.FrameEdgeHeight - overDraw, 
						omAuto, xf.FrameOpacity);
					copyFunc(layer, 
						.imageWidth - xf.cornerwidth, xf.cornerheight + y * xf.FrameEdgeHeight, wf0, 
						xf.cornerwidth + xf.FrameEdgeWidth, xf.cornerheight, xf.cornerwidth, xf.FrameEdgeHeight - overDraw, 
						omAuto, xf.FrameOpacity);
				}

				// l
				copyFunc(layer, 
					0, 0, wf0, 
					0, 0, xf.cornerwidth, xf.cornerheight, 
					omAuto, xf.frameopacity);
				copyFunc(layer, 
					.imageWidth - xf.cornerwidth, 0, wf0, 
					xf.cornerwidth + xf.FrameEdgeWidth, 0, xf.cornerwidth, xf.cornerheight, 
					omAuto, xf.frameopacity);
				copyFunc(layer, 
					0, .imageHeight - xf.cornerheight, wf0, 
					0, xf.cornerheight + xf.FrameEdgeHeight, xf.cornerwidth, xf.cornerheight, 
					omAuto, xf.frameopacity);
				copyFunc(layer, 
					.imageWidth - xf.cornerwidth, .imageHeight - xf.cornerheight, wf0, 
					xf.cornerwidth + xf.FrameEdgeWidth, xf.cornerheight + xf.FrameEdgeHeight, xf.cornerwidth, xf.cornerheight, 
					omAuto, xf.frameopacity);

			} /* end g */

		} /* end with */

		invalidate ch0;
		invalidate wf0;

		// LbV
		if (cacheinfo.enabled)
		{
			cacheinfo.width  = layer.imageWidth;
			cacheinfo.height = layer.imageHeight;
			cacheinfo.layernum = layernum;
			cachelayer.setImageSize(layer.imageWidth, layer.imageHeight);
			cachelayer.copyRect(0, 0, layer, 0, 0, layer.imageWidth, layer.imageHeight);
		}

		return true;
	}

	// gg̃o[WŐ؂ւB
	function setCopyFuncFlag(xftr)
	{
		this.copyFuncFlag = xftr ? cffOperate : cffCopy;
	}

	// Rs[֐
	function copyFunc(layer, dleft, dtop, src, sleft, stop, swidth, sheight, mode=omAuto, opa=255)
	{
		switch (this.copyFuncFlag)
		{
		case cffCopy:
			layer.copyRect(dleft, dtop, src, sleft, stop, swidth, sheight);
			break;
		case cffOperate:
			layer.operateRect(dleft, dtop, src, sleft, stop, swidth, sheight, mode, opa);
			break;
		default:
			break;
		}
	}


	// MessageLayer.clearLayer() 

	/*
	̂́AC[WɕύXƂ́A
	t[摜̗LɂďU蕪Ă镔B

	KAG̃o[WςꍇAeςꍇB
	āAǂ̂B
	*/

	function overrideLayerFunc(layernum)
	{
		var layer = window.fore.messages[layernum];

// begin MessageLayer.tjs  MessageLayer.clearLayer()
		layer.clearLayer = function() {

			// CNA
			window.updateBeforeCh = 1;

			cancelDrag();

			if(imageModified)
			{
//*** ǉ ***
				var exfo = global.exframe_object;
				var layn = kag.fore.messages.find(this);
				if (layn < 0) layn = kag.back.messages.find(this);

				// g[h
				if (layn >= 0 && exfo.ldic[layn] !== void)
				{
					face = dfAuto;
					fillRect(0, 0, imageWidth, imageHeight, (frameOpacity << 24) + frameColor);
					exfo.drawFrame(layn);
				}
				// ʏ탂[hF̂܂܂ŗǂ
				else
				{
//*** ܂Œǉ ***

				if(frameGraphic == "")
				{
					// t[摜w肳ĂȂꍇ
					face = dfAuto;
					fillRect(0, 0, imageWidth, imageHeight, (frameOpacity << 24) + frameColor);
				}
				else
				{
					loadImages(frameGraphic, frameKey);
					setSizeToImageSize();
				}

//*** ǉ ***
				}
//*** ܂Œǉ ***

				face = dfProvince;
				colorRect(0, 0, imageWidth, imageHeight, 0); // ̈NA
				face = dfAuto;
			}

			imageModified = false;

			invalidateLinkObjects(); // NɊ֘AÂꂽIuWFNg𖳌

			focusable = false;
			links.clear();
			numLinks = 0;
			inLink = -1;
			highlightLink(lastLink, false); // nCCg
			highlightLayer.visible = false;
			lastLink = -1;
			keyLink = -1;
			linkFilled = false;
			lastDrawnCh = ""; // Ōɕ`悵
			isLastLine = false; // ŏIs
			selClickLock = true;
			lastMouseX = cursorX;
			lastMouseY = cursorY;
			initLineLayer();
		} incontextof layer;
// end MessageLayer.tjs  MessageLayer.clearLayer()

	}


	// zɏ㏑ǉ
	// 2.23ȍ~ȂassignŒuB
	function addElem(src, dest)
	{
		var elmkeys = new Array();
		elmkeys.assign(src);
		for (var i = 0; i < elmkeys.count; i += 2)
		{
			var key = elmkeys[i];
			dest[key] = src[key];
		}
		invalidate elmkeys;
	}


	// fobOp
	// zԕ\
	function showDic(dic)
	{
		var t = new Array();
		t.assign(dic);
		System.inform("<" + t.join(">\n<") + ">");
	}



	function onStore(f, elm)
	{
		// xۑƂ
		// fnϐgp
		var dic = f.frame_extension_plugin_savedata = [];
		(Array.assignStruct incontextof dic)(ldic);
	}

	function onRestore(f, clear, elm)
	{
		// xǂݏoƂ
		var dic = f.frame_extension_plugin_savedata;

		initDefaultOptions();

		if(dic === void)
		{
			// 񂪞xɕۑĂȂ
		}
		else
		{
			// 񂪞xɕۑĂ
			// ǂݏo
			(Array.assignStruct incontextof ldic)(dic);
			// Kp
			for (var i = 0; i < ldic.count; i++)
			{
				var d = ldic[i];
				if (d !== void) setOptions(d);
			}
		}
	}

}


kag.addPlugin(global.exframe_object = new KAGFrameExtensionPlugin(kag));

@endscript
@endif

; }N̓o^

@macro name="exframe"
[eval exp="global.exframe_object.setOptions(mp)"]
@endmacro

@macro name="exframe_erase"
[eval exp="global.exframe_object.deleteOptions(mp)"]
@endmacro

@return
